/[sysadmin-cookbook]/recepies/lxc/lxc-watchdog.sh
This is repository of my old source code which isn't updated any more. Go to git.rot13.org for current projects!
ViewVC logotype

Contents of /recepies/lxc/lxc-watchdog.sh

Parent Directory Parent Directory | Revision Log Revision Log


Revision 227 - (show annotations)
Tue Sep 7 16:02:12 2010 UTC (9 years, 11 months ago) by dpavlin
File MIME type: application/x-sh
File size: 5131 byte(s)
don't try to start containers without rootfs mounted

1 #! /bin/sh
2 ### BEGIN INIT INFO
3 # Provides: lxc-watchdog
4 # Required-Start: $remote_fs $named $network $time
5 # Required-Stop: $remote_fs $named $network
6 # Required-Start:
7 # Required-Stop:
8 # Default-Start: 2 3 4 5
9 # Default-Stop: 0 1 6
10 # Short-Description: Manage Linux Containers startup/shutdown
11 # Description: Uses clever inotify hack to monitor container's
12 # halt/reboot events watching /var/run/utmp
13 ### END INIT INFO
14
15 # Author: Dobrica Pavlinusic <dpavlin@rot13.org>
16 #
17 # based on Tony Risinger post to lxc-users mailing list
18 # http://www.mail-archive.com/lxc-users@lists.sourceforge.net/msg00074.html
19 #
20 # Install with:
21 # ln -sf /srv/sysadmin-cookbook/recepies/lxc/lxc-watchdog.sh /etc/init.d/lxc-watchdog
22 # update-rc.d lxc-watchdog defaults
23
24
25 which inotifywait >/dev/null || apt-get install inotify-tools
26
27
28 lxc_exists() {
29 name=$1
30
31 if [ ! -e /var/lib/lxc/$name/config ] ; then
32 echo "Usage: $0 name"
33 lxc_status
34 exit 1
35 fi
36 }
37
38
39 lxc_rootfs() {
40 grep '^ *lxc\.rootfs *=' "/var/lib/lxc/$1/config" | cut -d= -f2 | sed 's/^ *//'
41 }
42
43
44 lxc_status() {
45 ( find /var/lib/lxc/ -name "config" | cut -d/ -f5 | sort -u | xargs -i lxc-info -n {} | sed "s/'//g" | while read name is status ; do
46 boot="-"
47 hostname=`cat $(lxc_rootfs $name)/etc/hostname`
48 ip=`grep address $(lxc_rootfs $name)/etc/network/interfaces | sed 's/.*address //'`
49 test -s /var/lib/lxc/$name/on_boot && boot="boot"
50 echo "$name $status $boot $(lxc_rootfs $name) $ip $hostname"
51 done ) | column -t
52 }
53
54
55 cleanup_init_scripts() {
56 rootfs=$(lxc_rootfs $1)
57
58 ls \
59 $rootfs/etc/rc?.d/*umountfs \
60 $rootfs/etc/rc?.d/*umountroot \
61 $rootfs/etc/rc?.d/*hwclock* \
62 $rootfs/etc/rc?.d/*udev* \
63 2>/dev/null | xargs -i rm -v {}
64
65 echo $1 > $rootfs/etc/hostname
66 }
67
68
69 setup_inittab() {
70 rootfs=$(lxc_rootfs $1)
71 remove=$2
72 add=$3
73
74 # let container respond to kill -SIGPWR
75 inittab=$rootfs/etc/inittab
76 if test -e $inittab && ! grep "$add" ${inittab} >/dev/null ; then
77 grep -v "$remove" ${inittab} > ${inittab}.new
78 echo $add >> ${inittab}.new
79 mv ${inittab}.new ${inittab}
80 echo "$inittab modified with $add"
81 fi
82 }
83
84
85 lxc_log() {
86 echo `date +%Y-%m-%dT%H:%M:%S` $*
87 }
88
89
90 lxc_kill() {
91 name=$1
92 sig=$2
93
94 init_pid=`lxc-ps -C init -o pid | grep "^$name" | cut -d" " -f2-`
95 if [ -z "$init_pid" ] ; then
96 lxc-info -n $name
97 exit 1
98 fi
99 lxc_log "$name kill $sig $init_pid"
100 /bin/kill $sig $init_pid
101 }
102
103 lxc_stop() {
104 lxc_log "$name stop"
105 lxc_kill $name -SIGPWR
106 lxc-wait -n $name -s STOPPED
107 lxc_log "$name stoped"
108 # rm -f /var/lib/lxc/${name}/on_boot
109 }
110
111
112 lxc_start() {
113 name=$1
114 rootfs=$(lxc_rootfs $1)
115
116 if [ ! -e $rootfs ] ; then
117 echo "ERROR $name rootfs $rootfs not found"
118 return
119 fi
120
121 if ! lxc-info -n $name | grep RUNNING ; then
122 lxc_log "$name start"
123 lxc-start -n $name -o /tmp/${name}.log -d
124 lxc-wait -n $name -s RUNNING
125 lxc-info -n $name
126 test -f /var/lib/lxc/${name}/on_boot || echo $name > /var/lib/lxc/${name}/on_boot
127 fi
128 }
129
130 lxc_watchdog() {
131 name=$1
132 rootfs=$(lxc_rootfs $1)
133
134 while true; do
135 vps_utmp=${rootfs}/var/run/utmp
136 tasks=`wc -l < /cgroup/${name}/tasks`
137 test -z "$tasks" && exit 1
138 if [ "$tasks" -eq 1 ]; then
139
140 runlevel="$(runlevel ${vps_utmp})"
141 lxc_log "$name runlevel $runlevel"
142
143 case $runlevel in
144 N*)
145 # nothing for new boot state
146 ;;
147 ??0)
148 lxc_log "$name halt"
149 lxc-stop -n "${name}"
150 lxc-wait -n ${name} -s STOPPED
151 break
152 ;;
153 ??6)
154 lxc_log "$name reboot";
155 lxc-stop -n ${name}
156 lxc-wait -n ${name} -s STOPPED
157 lxc-start -d -n ${name} -o /tmp/${name}.log
158 ;;
159 *)
160 # make sure vps is still running
161 state="$(lxc-info -n "${name}" | sed -e 's/.* is //')"
162 [ "$state" = "RUNNING" ] || break
163 ;;
164 esac
165 else
166 lxc_log "$name $tasks tasks"
167 fi
168
169 # time of 5 minutes on it JUST IN CASE...
170 inotifywait -qqt 300 ${vps_utmp}
171 done
172
173 lxc_log "$name watchdog exited"
174
175 }
176
177
178 usage() {
179 echo "Usage: $0 {start|stop|restart|status|boot|disable} [name name ... ]" >&2
180 exit 3
181 }
182
183 command_on_lxc() {
184 command=$1
185 shift
186
187 echo "# $command $1"
188
189 case "$command" in
190
191 start)
192 lxc_exists $1
193 cleanup_init_scripts $1
194 setup_inittab $1 ":respawn:/sbin/getty.*tty1" "c1:12345:respawn:/sbin/getty 38400 tty1 linux"
195 setup_inittab $1 "::power" "p0::powerfail:/sbin/init 0"
196 setup_inittab $1 "::ctrlaltdel" "p6::ctrlaltdel:/sbin/init 6"
197 lxc_start $1
198 # give container 5 seconds to start more than one process
199 ( sleep 5 ; nohup $0 watchdog $1 >> /tmp/$1.log 2>/dev/null ) &
200 ;;
201 stop|halt)
202 lxc_exists $1
203 lxc_stop $1
204 ;;
205 reload|force-reload|restart|reboot)
206 lxc_kill $1 -SIGINT
207 ;;
208 watchdog)
209 lxc_watchdog $1
210 ;;
211 boot)
212 echo $1 > /var/lib/lxc/$1/on_boot
213 ;;
214 disable)
215 echo -n > /var/lib/lxc/$1/on_boot
216 ;;
217 *)
218 usage
219 ;;
220
221 esac
222
223 }
224
225 command=$1
226 test -z "$command" && usage
227 test "$command" = "status" && lxc_status && exit
228 shift
229
230 if [ -z "$1" ] ; then
231 ls /var/lib/lxc/*/on_boot | while read path ; do
232 name=`echo $path | cut -d/ -f5`
233 if [ "$command" != "start" -o "$command" = "start" -a -s $path ] ; then
234 command_on_lxc $command $name
235 else
236 echo "# skip $command $name"
237 fi
238 done
239 else
240 while [ ! -z "$1" ] ; do
241 command_on_lxc $command $1
242 shift
243 done
244 fi
245

Properties

Name Value
svn:executable *

  ViewVC Help
Powered by ViewVC 1.1.26